/**
  * Copyright: Copyright(c) 2005-2009 朗慧科技,Inc.All Rights Reserved. 
  * Company: 朗慧科技
 */
package zhangcb.pps;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import org.dom4j.Document;
import org.dom4j.Element;

/**  
 *   Filename:		AnalysisXmlDocument.java
 *   Ttitle:     	类相关说明       
 *   Author:       	david
 *   Date:   		2009-9-10 
 *   Time:   		上午01:52:59 
 *   Version:   	1.0.0   
 */

public class AnalysisXmlDocument {
	
	public Object[] createRootData(Document document) {
        Element root = document.getRootElement();
        List<Element> rootData = root.elements("Class");
		Object[] datas = new Object[rootData.size()];
        for (int i=0;i<rootData.size();i++) {
			Element foo = rootData.get(i);
			//视频分类的唯一ID
			String id = foo.elementText("ID");
			String title = foo.elementText("Title");
			String type = foo.elementText("Type");
			String contentNum = foo.elementText("ContentNum");
			
			Map<String, String> data = new TreeMap<String, String>();
			data.put("id", id);
			data.put("title", title);
			data.put("type", type);
			data.put("contentNum", contentNum);
			data.put("level", "1");
			
			datas[i] = data;
		}  
        
        return datas;
	}
	
	public Object[] createMiddleData(Document document, String parentID, String type) {
		Object[] datas = null;
        Element root = document.getRootElement();
        if(type.equalsIgnoreCase("0")) {	//pps官方原定就有本分类
	        List<Element> rootData = root.elements("SubClass");
			datas = new Object[rootData.size()];
	        for (int i=0;i<rootData.size();i++) {
				Element foo = rootData.get(i);
				//视频二级分类的唯一ID
				String subid = foo.elementText("SubID");
				//视频二级分类的标题
				String title = foo.elementText("Title");
				//该二级分类下推荐影片的影片名称
				String filmTitle = foo.elementText("FilmTitle");
				//该二级分类下推荐影片的影片导演名
				String dirt = foo.elementText("Dirt");
				//该二级分类下推荐影片的影片演员名
				String actor = foo.elementText("Actor");
				//该二级分类下推荐影片的影片评分
				String score = foo.elementText("Score");
				//该二级分类下推荐影片的获取大海报的URL
				String biUrl = foo.elementText("BIUrl");
				//该二级分类下推荐影片的获取小海报的URL
				String siUrl = foo.elementText("SIUrl");
				//标记该视频二级分类下有多少节目
				String contentNum = foo.elementText("ContentNum");
				
				Map<String, String> data = new TreeMap<String, String>();
				data.put("parentID", parentID);
				data.put("subid", subid);
				data.put("title", title);
				data.put("filmTitle", filmTitle);
				data.put("dirt", dirt);
				data.put("actor", actor);
				data.put("score", score);
				data.put("biUrl", biUrl);
				data.put("siUrl", siUrl);
				data.put("contentNum", contentNum);
				data.put("level", "2");
				
				datas[i] = data;
			}  
        }else {	//pps官方原定没有本分类，例如内地剧场等，我们在这里构造此分类
	        List<Element> rootData = root.elements("Film");
			datas = new Object[rootData.size()];
	        for (int i=0;i<rootData.size();i++) {
				Element foo = rootData.get(i);
				//视频二级分类的标题
				String title = foo.elementText("Title");
				//标记该视频二级分类下有多少节目
				String contentNum = foo.elementText("CN");

	        	
				Map<String, String> data = new TreeMap<String, String>();
				data.put("parentID", parentID);
				data.put("subid", "0");
				data.put("title", title);
				data.put("contentNum", contentNum);
				data.put("level", "2");

				datas[i] = data;
	        }
        }
        return datas;
	}
	
	public Object[] createbottomData(Document document, String subid, String parentTitle) {
		List<Map<String, String>> l = new ArrayList<Map<String, String>>();
        Element root = document.getRootElement();
        List<Element> rootData = root.elements("Film");
        
        
        for (int i=0;i<rootData.size();i++) {
			Element foo = rootData.get(i);
			//视频节目的标题
			String title = foo.elementText("Title");

	        if(subid.equalsIgnoreCase("0")) {
	        	if(!title.trim().equalsIgnoreCase(parentTitle.trim())) {
	        		continue;
	        	}
	        }
			
			
			//该视频节目的演员名
			String actor = foo.elementText("Actor");
			//标记该视频节目集数
			String cn = foo.elementText("CN");
			
			List<Element> subData = foo.element("Down").elements("Url");
			for(int j=0;j<subData.size();j++) {
				Element sub = subData.get(j);
				
				//表示第几集
				String ci = sub.elementText("CI");
				//该集视频点播地址
				String dUrl = sub.elementText("DUrl");
				//标记该集视频是否需要VIP权限才能观看，VF=1表示需要VIP权限，VF=0表述不需要VIP权限
				String vf = sub.elementText("VF");
				
				Map<String, String> data = new TreeMap<String, String>();
				data.put("title", title);
				data.put("actor", actor);
				data.put("cn", cn);
				data.put("ci", ci);
				data.put("dUrl", dUrl);
				data.put("vf", vf);
				data.put("level", "3");
				
				l.add(data);
			}
        }
        Object[] datas = new Object[l.size()];
        datas = l.toArray(datas);
        return datas;
	}
	
}
