/**
  * Copyright: Copyright(c) 2005-2009 朗慧科技,Inc.All Rights Reserved. 
  * Company: 朗慧科技
 */
package zhangcb.pps;

import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.util.Map;
import java.util.Properties;

import org.dom4j.Document;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

import zhangcb.pps.common.PPS;

/**  
 *   Filename:		ChannelTree.java
 *   Ttitle:     	频道树       
 *   Author:       	david
 *   Date:   		2009-9-10 
 *   Time:   		上午12:47:34 
 *   Version:   	1.0.0   
 */

public class ChannelTree extends Composite {
	
	private TreeViewer treeViewer;
	
	private CreateXmlDocument createXmlDocument = new CreateXmlDocument();

	private AnalysisXmlDocument analysisXmlDocument = new AnalysisXmlDocument();
	
	private Shell shell = null; 
	
	public ChannelTree(Composite parent) {
		super(parent, SWT.None);

		shell = this.getShell();
		
		FillLayout fillLayout = new FillLayout();
		this.setLayout(fillLayout);
		
		treeViewer = new TreeViewer(this);
	
		treeViewer.getControl().addMouseListener(new MouseAdapter(){
			@Override
			public void mouseDoubleClick(MouseEvent e) {
				TreeItem item = ((Tree)e.getSource()).getSelection()[0];
				final Map<String, String> data = (Map<String, String>)item.getData();
				int level = Integer.parseInt((String)data.get("level"));
				if(level == 3) {
					String ppshome = PPS.config.getProperty(PPS.PPS_HOME);
					
					File mplayer = new File(ppshome+"/mplayer");
					if(!mplayer.exists()) {
						MessageBox msg = new MessageBox(shell, SWT.ICON_ERROR);
						msg.setMessage("未找到PPS客户端\n请在工具－选项中设置正确的pps客户端安装目录");
						msg.setText("错误");
						msg.open();
						return;
					}
					
					final String cmd = "sudo "+ppshome+"/mplayer "+data.get("dUrl");
					
					System.out.println("以获取播放地址，现在开始播放");
					System.out.println(cmd);
					new Thread(new Runnable(){
						@Override
						public void run() {
							try {
							Process process = Runtime.getRuntime().exec(cmd);
				            InputStreamReader ir=new InputStreamReader(process.getInputStream());
				            LineNumberReader input=new LineNumberReader(ir);
				            String line = "";
				            while((line=input.readLine())!=null){
				            	System.out.println(line);
				            }
						
							}catch(IOException ex) {
								ex.printStackTrace();
							}
						}
					}).start();

//			            process.waitFor();
				}
			}
		});
		
		treeViewer.setContentProvider(new ResultSetContentProvider());
		
		Document document = createXmlDocument.create("http://playlist.pps.tv/classfortv.php");
		Object[] datas = analysisXmlDocument.createRootData(document);
		
		treeViewer.setInput(datas);
		
		treeViewer.setLabelProvider(new ResultSetLabelProvider());
	}
}

class ResultSetContentProvider implements ITreeContentProvider {
	
	private CreateXmlDocument createXmlDocument = new CreateXmlDocument();

	private AnalysisXmlDocument analysisXmlDocument = new AnalysisXmlDocument();
	
	@Override
	public Object[] getChildren(Object parentElement) {	//获取子节点
		Object[] datas = null;
		String url = "";
		Document document = null;
		Map<String, String> data = (Map<String, String>)parentElement;
		int level = Integer.parseInt(data.get("level"));
		switch(level) {
		case 1:
			if(data.get("type").equalsIgnoreCase("0")) {
				url = "http://playlist.pps.tv/subclassfortv.php?class="+data.get("id");
			}else {
				url = "http://playlist.pps.tv/channelsfortv.php?class="+data.get("id")+"&subclass=0";
			}
			document = createXmlDocument.create(url);
			datas = analysisXmlDocument.createMiddleData(document, data.get("id"), data.get("type"));
			break;
		case 2:
			if(data.get("subid").equalsIgnoreCase("0")) {
				url = "http://playlist.pps.tv/channelsfortv.php?class="+data.get("parentID")+"&subclass=0";
			}else {
				url = "http://playlist.pps.tv/channelsfortv.php?class="+data.get("parentID")+"&subclass="+data.get("subid")+"&page=1";
			}
			document = createXmlDocument.create(url);
			datas = analysisXmlDocument.createbottomData(document, data.get("subid"), data.get("title"));
			break;
		}
		return datas;
	}
	
	@Override
	public Object[] getElements(Object inputElement) {	//初始化根节点
		return (Object[])inputElement;
	}
	
	@Override
	public boolean hasChildren(Object parentElement) {	//判断是否有子节点
		Map<String, String> data = (Map<String, String>)parentElement;
		if(data.get("level").equalsIgnoreCase("3")) {
			return false;
		}else {
			return true;
		}
	}
	
	@Override
	public Object getParent(Object arg0) {
		return null;
	}
	
	@Override
	public void inputChanged(Viewer arg0, Object arg1, Object arg2) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void dispose() {
		// TODO Auto-generated method stub
		
	}
}

class ResultSetLabelProvider extends LabelProvider {
	
	@Override
	public String getText(Object element) {
		Map<String, String> data = (Map<String, String>)element;
		StringBuilder text = new StringBuilder();
		if(data.get("level").equalsIgnoreCase("3")) {
			if(data.get("cn").equalsIgnoreCase("1")) {
				text.append(data.get("title")).append("(").append(data.get("actor")).append(")");
			}else {
				text.append(data.get("title")).append("-").append(data.get("ci")).append("-");
			}
		}else {
			text.append(data.get("title")).append("(").append(data.get("contentNum")).append(")");
		}
		return text.toString();
	}
	
}
