/**
  * Copyright: Copyright(c) 2005-2009 朗慧科技,Inc.All Rights Reserved. 
  * Company: 朗慧科技
 */
package zhangcb.pps;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URISyntaxException;

import org.eclipse.jface.window.ApplicationWindow;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;

import zhangcb.pps.common.PPS;
import zhangcb.pps.config.ConfigSetWindow;

/**  
 *   Filename:		Client.java
 *   Ttitle:     	主程序入口     
 *   Author:       	david
 *   Date:   		2009-9-10 
 *   Time:   		上午12:38:53 
 *   Version:   	1.0.0   
 */

public class Client extends ApplicationWindow {
	private Shell shell;
	
	public Client() {
		super(null);
		try {
			PPS.file = new File(this.getClass().getResource("config.properties").toURI());
			if(PPS.config.isEmpty()) {
				PPS.config.load(new FileInputStream(PPS.file));
			}
		}catch(IOException e) {
			e.printStackTrace();
		}catch(URISyntaxException e) {
			e.printStackTrace();
		}
	}
	
	@Override
	protected Control createContents(Composite parent) {
		shell = parent.getShell();
		shell.setText("client for pps 0.1");
		
		mainLayout(parent);
		
		shell.setSize(400, 600);
		return parent;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Client c = new Client();		
		c.setBlockOnOpen(true);
		
		c.open();
		
		c.doDispose();
	}
	
	private void doDispose() {
		try {
			PPS.config.store(new FileOutputStream(PPS.file), "");
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		Display.getCurrent().dispose();
	}
	
	private void mainLayout(final Composite parent) {
		Menu menu = new Menu(shell,SWT.BAR);
		MenuItem file = new MenuItem(menu,SWT.CASCADE);
		file.setText("工具");
		Menu fileMenu = new Menu(shell,SWT.DROP_DOWN);
		file.setMenu(fileMenu);

		MenuItem connect = new MenuItem(fileMenu,SWT.PUSH);
		connect.setText("选项");
		connect.addSelectionListener(new SelectionAdapter(){
			@Override
			public void widgetSelected(SelectionEvent arg0) {
				ConfigSetWindow config = new ConfigSetWindow();
				config.open();
			}
		});
	
		shell.setMenuBar(menu);
		new MainComposite(parent);
	}
}
