/**
  * Copyright: Copyright(c) 2005-2009 朗慧科技,Inc.All Rights Reserved. 
  * Company: 朗慧科技
 */
package zhangcb.pps.config;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import org.eclipse.jface.window.ApplicationWindow;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import zhangcb.pps.common.PPS;

/**  
 *   Filename:		ConfigSetWindow.java
 *   Ttitle:     	设置窗口       
 *   Author:       	david
 *   Date:   		2009-9-11 
 *   Time:   		下午10:24:07 
 *   Version:   	1.0.0   
 */

public class ConfigSetWindow extends ApplicationWindow {
	
	private Shell shell;
	
	public ConfigSetWindow() {
		super(null);
	}
	
	@Override
	protected Control createContents(Composite parent) {
		shell = parent.getShell();
		shell.setText("设置");
		shell.setSize(300, 200);

		FormLayout layout = new FormLayout();
		parent.setLayout(layout);
		FormData data = new FormData();
		data.top = new FormAttachment(0,0);
		data.left = new FormAttachment(0,0);
		data.right = new FormAttachment(100);
		data.bottom = new FormAttachment(75);
		
		ConfigSetComposite c = new ConfigSetComposite(parent);
		c.setLayoutData(data);

		ButtonComposite b = new ButtonComposite(parent);
		data = new FormData();
		data.top = new FormAttachment(c);
		b.setLayoutData(data);		
		
		
		return parent;
	}
	
	public static void main(String args[]) {
		ConfigSetWindow c = new ConfigSetWindow();
		
		c.setBlockOnOpen(true);
		
		c.open();
		
		Display.getCurrent().dispose();
		
	}
	
}
class ButtonComposite extends Composite {
	public ButtonComposite(final Composite parent) {
		super(parent, SWT.NONE);
		RowLayout rowLayout = new RowLayout();
		setLayout(rowLayout);
		
		RowData rowData = new RowData();
		rowData.height = 30;
		rowData.width = 60;

		Button ok = new Button(this, SWT.PUSH);
		ok.setText("Ok");
		ok.setLayoutData(rowData);
		
		ok.addMouseListener(new MouseAdapter(){
			@Override
			public void mouseDown(MouseEvent e) {
				Text t = (Text)parent.getData("pps_home_text");
				if(PPS.config.containsKey(PPS.PPS_HOME)) {
					PPS.config.setProperty(PPS.PPS_HOME, t.getText());
				}else {
					PPS.config.put(PPS.PPS_HOME, t.getText());
				}
				parent.dispose();
			}
		});
		
		Button cancel = new Button(this, SWT.PUSH);
		cancel.setText("Cancel");
		cancel.setLayoutData(rowData);
	}
}